#pragma once

namespace orbis {
enum Syscall {
  kSYS_syscall = 0,
  kSYS_exit = 1,
  kSYS_fork = 2,
  kSYS_read = 3,
  kSYS_write = 4,
  kSYS_open = 5,
  kSYS_close = 6,
  kSYS_wait4 = 7,
  kSYS_link = 9,
  kSYS_unlink = 10,
  kSYS_chdir = 12,
  kSYS_fchdir = 13,
  kSYS_mknod = 14,
  kSYS_chmod = 15,
  kSYS_chown = 16,
  kSYS_break = 17,
  kSYS_freebsd4_getfsstat = 18,
  kSYS_getpid = 20,
  kSYS_mount = 21,
  kSYS_unmount = 22,
  kSYS_setuid = 23,
  kSYS_getuid = 24,
  kSYS_geteuid = 25,
  kSYS_ptrace = 26,
  kSYS_recvmsg = 27,
  kSYS_sendmsg = 28,
  kSYS_recvfrom = 29,
  kSYS_accept = 30,
  kSYS_getpeername = 31,
  kSYS_getsockname = 32,
  kSYS_access = 33,
  kSYS_chflags = 34,
  kSYS_fchflags = 35,
  kSYS_sync = 36,
  kSYS_kill = 37,
  kSYS_getppid = 39,
  kSYS_dup = 41,
  kSYS_pipe = 42,
  kSYS_getegid = 43,
  kSYS_profil = 44,
  kSYS_ktrace = 45,
  kSYS_getgid = 47,
  kSYS_getlogin = 49,
  kSYS_setlogin = 50,
  kSYS_acct = 51,
  kSYS_sigaltstack = 53,
  kSYS_ioctl = 54,
  kSYS_reboot = 55,
  kSYS_revoke = 56,
  kSYS_symlink = 57,
  kSYS_readlink = 58,
  kSYS_execve = 59,
  kSYS_umask = 60,
  kSYS_chroot = 61,
  kSYS_msync = 65,
  kSYS_vfork = 66,
  kSYS_sbrk = 69,
  kSYS_sstk = 70,
  kSYS_vadvise = 72,
  kSYS_munmap = 73,
  kSYS_mprotect = 74,
  kSYS_madvise = 75,
  kSYS_mincore = 78,
  kSYS_getgroups = 79,
  kSYS_setgroups = 80,
  kSYS_getpgrp = 81,
  kSYS_setpgid = 82,
  kSYS_setitimer = 83,
  kSYS_swapon = 85,
  kSYS_getitimer = 86,
  kSYS_getdtablesize = 89,
  kSYS_dup2 = 90,
  kSYS_fcntl = 92,
  kSYS_select = 93,
  kSYS_fsync = 95,
  kSYS_setpriority = 96,
  kSYS_socket = 97,
  kSYS_connect = 98,
  kSYS_getpriority = 100,
  kSYS_bind = 104,
  kSYS_setsockopt = 105,
  kSYS_listen = 106,
  kSYS_gettimeofday = 116,
  kSYS_getrusage = 117,
  kSYS_getsockopt = 118,
  kSYS_readv = 120,
  kSYS_writev = 121,
  kSYS_settimeofday = 122,
  kSYS_fchown = 123,
  kSYS_fchmod = 124,
  kSYS_setreuid = 126,
  kSYS_setregid = 127,
  kSYS_rename = 128,
  kSYS_flock = 131,
  kSYS_mkfifo = 132,
  kSYS_sendto = 133,
  kSYS_shutdown = 134,
  kSYS_socketpair = 135,
  kSYS_mkdir = 136,
  kSYS_rmdir = 137,
  kSYS_utimes = 138,
  kSYS_adjtime = 140,
  kSYS_setsid = 147,
  kSYS_quotactl = 148,
  kSYS_nlm_syscall = 154,
  kSYS_nfssvc = 155,
  kSYS_freebsd4_statfs = 157,
  kSYS_freebsd4_fstatfs = 158,
  kSYS_lgetfh = 160,
  kSYS_getfh = 161,
  kSYS_freebsd4_getdomainname = 162,
  kSYS_freebsd4_setdomainname = 163,
  kSYS_freebsd4_uname = 164,
  kSYS_sysarch = 165,
  kSYS_rtprio = 166,
  kSYS_semsys = 169,
  kSYS_msgsys = 170,
  kSYS_shmsys = 171,
  kSYS_freebsd6_pread = 173,
  kSYS_freebsd6_pwrite = 174,
  kSYS_setfib = 175,
  kSYS_ntp_adjtime = 176,
  kSYS_setgid = 181,
  kSYS_setegid = 182,
  kSYS_seteuid = 183,
  kSYS_stat = 188,
  kSYS_fstat = 189,
  kSYS_lstat = 190,
  kSYS_pathconf = 191,
  kSYS_fpathconf = 192,
  kSYS_getrlimit = 194,
  kSYS_setrlimit = 195,
  kSYS_getdirentries = 196,
  kSYS_freebsd6_mmap = 197,
  kSYS___syscall = 198,
  kSYS_freebsd6_lseek = 199,
  kSYS_freebsd6_truncate = 200,
  kSYS_freebsd6_ftruncate = 201,
  kSYS___sysctl = 202,
  kSYS_mlock = 203,
  kSYS_munlock = 204,
  kSYS_undelete = 205,
  kSYS_futimes = 206,
  kSYS_getpgid = 207,
  kSYS_poll = 209,
  kSYS_freebsd7___semctl = 220,
  kSYS_semget = 221,
  kSYS_semop = 222,
  kSYS_freebsd7_msgctl = 224,
  kSYS_msgget = 225,
  kSYS_msgsnd = 226,
  kSYS_msgrcv = 227,
  kSYS_shmat = 228,
  kSYS_freebsd7_shmctl = 229,
  kSYS_shmdt = 230,
  kSYS_shmget = 231,
  kSYS_clock_gettime = 232,
  kSYS_clock_settime = 233,
  kSYS_clock_getres = 234,
  kSYS_ktimer_create = 235,
  kSYS_ktimer_delete = 236,
  kSYS_ktimer_settime = 237,
  kSYS_ktimer_gettime = 238,
  kSYS_ktimer_getoverrun = 239,
  kSYS_nanosleep = 240,
  kSYS_ffclock_getcounter = 241,
  kSYS_ffclock_setestimate = 242,
  kSYS_ffclock_getestimate = 243,
  kSYS_clock_getcpuclockid2 = 247,
  kSYS_ntp_gettime = 248,
  kSYS_minherit = 250,
  kSYS_rfork = 251,
  kSYS_openbsd_poll = 252,
  kSYS_issetugid = 253,
  kSYS_lchown = 254,
  kSYS_aio_read = 255,
  kSYS_aio_write = 256,
  kSYS_lio_listio = 257,
  kSYS_getdents = 272,
  kSYS_lchmod = 274,
  kSYS_netbsd_lchown = 275,
  kSYS_lutimes = 276,
  kSYS_netbsd_msync = 277,
  kSYS_nstat = 278,
  kSYS_nfstat = 279,
  kSYS_nlstat = 280,
  kSYS_preadv = 289,
  kSYS_pwritev = 290,
  kSYS_freebsd4_fhstatfs = 297,
  kSYS_fhopen = 298,
  kSYS_fhstat = 299,
  kSYS_modnext = 300,
  kSYS_modstat = 301,
  kSYS_modfnext = 302,
  kSYS_modfind = 303,
  kSYS_kldload = 304,
  kSYS_kldunload = 305,
  kSYS_kldfind = 306,
  kSYS_kldnext = 307,
  kSYS_kldstat = 308,
  kSYS_kldfirstmod = 309,
  kSYS_getsid = 310,
  kSYS_setresuid = 311,
  kSYS_setresgid = 312,
  kSYS_aio_return = 314,
  kSYS_aio_suspend = 315,
  kSYS_aio_cancel = 316,
  kSYS_aio_error = 317,
  kSYS_oaio_read = 318,
  kSYS_oaio_write = 319,
  kSYS_olio_listio = 320,
  kSYS_yield = 321,
  kSYS_mlockall = 324,
  kSYS_munlockall = 325,
  kSYS___getcwd = 326,
  kSYS_sched_setparam = 327,
  kSYS_sched_getparam = 328,
  kSYS_sched_setscheduler = 329,
  kSYS_sched_getscheduler = 330,
  kSYS_sched_yield = 331,
  kSYS_sched_get_priority_max = 332,
  kSYS_sched_get_priority_min = 333,
  kSYS_sched_rr_get_interval = 334,
  kSYS_utrace = 335,
  kSYS_freebsd4_sendfile = 336,
  kSYS_kldsym = 337,
  kSYS_jail = 338,
  kSYS_nnpfs_syscall = 339,
  kSYS_sigprocmask = 340,
  kSYS_sigsuspend = 341,
  kSYS_freebsd4_sigaction = 342,
  kSYS_sigpending = 343,
  kSYS_freebsd4_sigreturn = 344,
  kSYS_sigtimedwait = 345,
  kSYS_sigwaitinfo = 346,
  kSYS___acl_get_file = 347,
  kSYS___acl_set_file = 348,
  kSYS___acl_get_fd = 349,
  kSYS___acl_set_fd = 350,
  kSYS___acl_delete_file = 351,
  kSYS___acl_delete_fd = 352,
  kSYS___acl_aclcheck_file = 353,
  kSYS___acl_aclcheck_fd = 354,
  kSYS_extattrctl = 355,
  kSYS_extattr_set_file = 356,
  kSYS_extattr_get_file = 357,
  kSYS_extattr_delete_file = 358,
  kSYS_aio_waitcomplete = 359,
  kSYS_getresuid = 360,
  kSYS_getresgid = 361,
  kSYS_kqueue = 362,
  kSYS_kevent = 363,
  kSYS_extattr_set_fd = 371,
  kSYS_extattr_get_fd = 372,
  kSYS_extattr_delete_fd = 373,
  kSYS___setugid = 374,
  kSYS_eaccess = 376,
  kSYS_afs3_syscall = 377,
  kSYS_nmount = 378,
  kSYS___mac_get_proc = 384,
  kSYS___mac_set_proc = 385,
  kSYS___mac_get_fd = 386,
  kSYS___mac_get_file = 387,
  kSYS___mac_set_fd = 388,
  kSYS___mac_set_file = 389,
  kSYS_kenv = 390,
  kSYS_lchflags = 391,
  kSYS_uuidgen = 392,
  kSYS_sendfile = 393,
  kSYS_mac_syscall = 394,
  kSYS_getfsstat = 395,
  kSYS_statfs = 396,
  kSYS_fstatfs = 397,
  kSYS_fhstatfs = 398,
  kSYS_ksem_close = 400,
  kSYS_ksem_post = 401,
  kSYS_ksem_wait = 402,
  kSYS_ksem_trywait = 403,
  kSYS_ksem_init = 404,
  kSYS_ksem_open = 405,
  kSYS_ksem_unlink = 406,
  kSYS_ksem_getvalue = 407,
  kSYS_ksem_destroy = 408,
  kSYS___mac_get_pid = 409,
  kSYS___mac_get_link = 410,
  kSYS___mac_set_link = 411,
  kSYS_extattr_set_link = 412,
  kSYS_extattr_get_link = 413,
  kSYS_extattr_delete_link = 414,
  kSYS___mac_execve = 415,
  kSYS_sigaction = 416,
  kSYS_sigreturn = 417,
  kSYS_getcontext = 421,
  kSYS_setcontext = 422,
  kSYS_swapcontext = 423,
  kSYS_swapoff = 424,
  kSYS___acl_get_link = 425,
  kSYS___acl_set_link = 426,
  kSYS___acl_delete_link = 427,
  kSYS___acl_aclcheck_link = 428,
  kSYS_sigwait = 429,
  kSYS_thr_create = 430,
  kSYS_thr_exit = 431,
  kSYS_thr_self = 432,
  kSYS_thr_kill = 433,
  kSYS__umtx_lock = 434,
  kSYS__umtx_unlock = 435,
  kSYS_jail_attach = 436,
  kSYS_extattr_list_fd = 437,
  kSYS_extattr_list_file = 438,
  kSYS_extattr_list_link = 439,
  kSYS_ksem_timedwait = 441,
  kSYS_thr_suspend = 442,
  kSYS_thr_wake = 443,
  kSYS_kldunloadf = 444,
  kSYS_audit = 445,
  kSYS_auditon = 446,
  kSYS_getauid = 447,
  kSYS_setauid = 448,
  kSYS_getaudit = 449,
  kSYS_setaudit = 450,
  kSYS_getaudit_addr = 451,
  kSYS_setaudit_addr = 452,
  kSYS_auditctl = 453,
  kSYS__umtx_op = 454,
  kSYS_thr_new = 455,
  kSYS_sigqueue = 456,
  kSYS_kmq_open = 457,
  kSYS_kmq_setattr = 458,
  kSYS_kmq_timedreceive = 459,
  kSYS_kmq_timedsend = 460,
  kSYS_kmq_notify = 461,
  kSYS_kmq_unlink = 462,
  kSYS_abort2 = 463,
  kSYS_thr_set_name = 464,
  kSYS_aio_fsync = 465,
  kSYS_rtprio_thread = 466,
  kSYS_sctp_peeloff = 471,
  kSYS_sctp_generic_sendmsg = 472,
  kSYS_sctp_generic_sendmsg_iov = 473,
  kSYS_sctp_generic_recvmsg = 474,
  kSYS_pread = 475,
  kSYS_pwrite = 476,
  kSYS_mmap = 477,
  kSYS_lseek = 478,
  kSYS_truncate = 479,
  kSYS_ftruncate = 480,
  kSYS_thr_kill2 = 481,
  kSYS_shm_open = 482,
  kSYS_shm_unlink = 483,
  kSYS_cpuset = 484,
  kSYS_cpuset_setid = 485,
  kSYS_cpuset_getid = 486,
  kSYS_cpuset_getaffinity = 487,
  kSYS_cpuset_setaffinity = 488,
  kSYS_faccessat = 489,
  kSYS_fchmodat = 490,
  kSYS_fchownat = 491,
  kSYS_fexecve = 492,
  kSYS_fstatat = 493,
  kSYS_futimesat = 494,
  kSYS_linkat = 495,
  kSYS_mkdirat = 496,
  kSYS_mkfifoat = 497,
  kSYS_mknodat = 498,
  kSYS_openat = 499,
  kSYS_readlinkat = 500,
  kSYS_renameat = 501,
  kSYS_symlinkat = 502,
  kSYS_unlinkat = 503,
  kSYS_posix_openpt = 504,
  kSYS_gssd_syscall = 505,
  kSYS_jail_get = 506,
  kSYS_jail_set = 507,
  kSYS_jail_remove = 508,
  kSYS_closefrom = 509,
  kSYS___semctl = 510,
  kSYS_msgctl = 511,
  kSYS_shmctl = 512,
  kSYS_lpathconf = 513,
  kSYS_cap_new = 514,
  kSYS_cap_getrights = 515,
  kSYS_cap_enter = 516,
  kSYS_cap_getmode = 517,
  kSYS_pdfork = 518,
  kSYS_pdkill = 519,
  kSYS_pdgetpid = 520,
  kSYS_pselect = 522,
  kSYS_getloginclass = 523,
  kSYS_setloginclass = 524,
  kSYS_rctl_get_racct = 525,
  kSYS_rctl_get_rules = 526,
  kSYS_rctl_get_limits = 527,
  kSYS_rctl_add_rule = 528,
  kSYS_rctl_remove_rule = 529,
  kSYS_posix_fallocate = 530,
  kSYS_posix_fadvise = 531,

  kSYS_netcontrol = 99,
  kSYS_netabort = 101,
  kSYS_netgetsockinfo = 102,
  kSYS_socketex = 113,
  kSYS_socketclose = 114,
  kSYS_netgetiflist = 125,
  kSYS_kqueueex = 141,
  kSYS_mtypeprotect = 379,
  kSYS_regmgr_call = 532,
  kSYS_jitshm_create = 533,
  kSYS_jitshm_alias = 534,
  kSYS_dl_get_list = 535,
  kSYS_dl_get_info = 536,
  kSYS_dl_notify_event = 537,
  kSYS_evf_create = 538,
  kSYS_evf_delete = 539,
  kSYS_evf_open = 540,
  kSYS_evf_close = 541,
  kSYS_evf_wait = 542,
  kSYS_evf_trywait = 543,
  kSYS_evf_set = 544,
  kSYS_evf_clear = 545,
  kSYS_evf_cancel = 546,
  kSYS_query_memory_protection = 547,
  kSYS_batch_map = 548,
  kSYS_osem_create = 549,
  kSYS_osem_delete = 550,
  kSYS_osem_open = 551,
  kSYS_osem_close = 552,
  kSYS_osem_wait = 553,
  kSYS_osem_trywait = 554,
  kSYS_osem_post = 555,
  kSYS_osem_cancel = 556,
  kSYS_namedobj_create = 557,
  kSYS_namedobj_delete = 558,
  kSYS_set_vm_container = 559,
  kSYS_debug_init = 560,
  kSYS_suspend_process = 561,
  kSYS_resume_process = 562,
  kSYS_opmc_enable = 563,
  kSYS_opmc_disable = 564,
  kSYS_opmc_set_ctl = 565,
  kSYS_opmc_set_ctr = 566,
  kSYS_opmc_get_ctr = 567,
  kSYS_budget_create = 568,
  kSYS_budget_delete = 569,
  kSYS_budget_get = 570,
  kSYS_budget_set = 571,
  kSYS_virtual_query = 572,
  kSYS_mdbg_call = 573,
  kSYS_obs_sblock_create = 574,
  kSYS_obs_sblock_delete = 575,
  kSYS_obs_sblock_enter = 576,
  kSYS_obs_sblock_exit = 577,
  kSYS_obs_sblock_xenter = 578,
  kSYS_obs_sblock_xexit = 579,
  kSYS_obs_eport_create = 580,
  kSYS_obs_eport_delete = 581,
  kSYS_obs_eport_trigger = 582,
  kSYS_obs_eport_open = 583,
  kSYS_obs_eport_close = 584,
  kSYS_is_in_sandbox = 585,
  kSYS_dmem_container = 586,
  kSYS_get_authinfo = 587,
  kSYS_mname = 588,
  kSYS_dynlib_dlopen = 589,
  kSYS_dynlib_dlclose = 590,
  kSYS_dynlib_dlsym = 591,
  kSYS_dynlib_get_list = 592,
  kSYS_dynlib_get_info = 593,
  kSYS_dynlib_load_prx = 594,
  kSYS_dynlib_unload_prx = 595,
  kSYS_dynlib_do_copy_relocations = 596,
  kSYS_dynlib_prepare_dlclose = 597,
  kSYS_dynlib_get_proc_param = 598,
  kSYS_dynlib_process_needed_and_relocate = 599,
  kSYS_sandbox_path = 600,
  kSYS_mdbg_service = 601,
  kSYS_randomized_path = 602,
  kSYS_rdup = 603,
  kSYS_dl_get_metadata = 604,
  kSYS_workaround8849 = 605,
  kSYS_is_development_mode = 606,
  kSYS_get_self_auth_info = 607,
  kSYS_dynlib_get_info_ex = 608,
  kSYS_budget_getid = 609,
  kSYS_budget_get_ptype = 610,
  kSYS_get_paging_stats_of_all_threads = 611,
  kSYS_get_proc_type_info = 612,
  kSYS_get_resident_count = 613,
  kSYS_prepare_to_suspend_process = 614,
  kSYS_get_resident_fmem_count = 615,
  kSYS_thr_get_name = 616,
  kSYS_set_gpo = 617,
  kSYS_get_paging_stats_of_all_objects = 618,
  kSYS_test_debug_rwmem = 619,
  kSYS_free_stack = 620,
  kSYS_suspend_system = 621,
  kSYS_ipmimgr_call = 622,
  kSYS_get_gpo = 623,
  kSYS_get_vm_map_timestamp = 624,
  kSYS_opmc_set_hw = 625,
  kSYS_opmc_get_hw = 626,
  kSYS_get_cpu_usage_all = 627,
  kSYS_mmap_dmem = 628,
  kSYS_physhm_open = 629,
  kSYS_physhm_unlink = 630,
  kSYS_resume_internal_hdd = 631,
  kSYS_thr_suspend_ucontext = 632,
  kSYS_thr_resume_ucontext = 633,
  kSYS_thr_get_ucontext = 634,
  kSYS_thr_set_ucontext = 635,
  kSYS_set_timezone_info = 636,
  kSYS_set_phys_fmem_limit = 637,
  kSYS_utc_to_localtime = 638,
  kSYS_localtime_to_utc = 639,
  kSYS_set_uevt = 640,
  kSYS_get_cpu_usage_proc = 641,
  kSYS_get_map_statistics = 642,
  kSYS_set_chicken_switches = 643,
  kSYS_extend_page_table_pool = 644,
  kSYS_extend_page_table_pool2 = 645,
  kSYS_get_kernel_mem_statistics = 646,
  kSYS_get_sdk_compiled_version = 647,
  kSYS_app_state_change = 648,
  kSYS_dynlib_get_obj_member = 649,
  kSYS_budget_get_ptype_of_budget = 650,
  kSYS_prepare_to_resume_process = 651,
  kSYS_process_terminate = 652,
  kSYS_blockpool_open = 653,
  kSYS_blockpool_map = 654,
  kSYS_blockpool_unmap = 655,
  kSYS_dynlib_get_info_for_libdbg = 656,
  kSYS_blockpool_batch = 657,
  kSYS_fdatasync = 658,
  kSYS_dynlib_get_list2 = 659,
  kSYS_dynlib_get_info2 = 660,
  kSYS_aio_submit = 661,
  kSYS_aio_multi_delete = 662,
  kSYS_aio_multi_wait = 663,
  kSYS_aio_multi_poll = 664,
  kSYS_aio_get_data = 665,
  kSYS_aio_multi_cancel = 666,
  kSYS_get_bio_usage_all = 667,
  kSYS_aio_create = 668,
  kSYS_aio_submit_cmd = 669,
  kSYS_aio_init = 670,
  kSYS_get_page_table_stats = 671,
  kSYS_dynlib_get_list_for_libdbg = 672,
  kSYS_blockpool_move = 673,
  kSYS_virtual_query_all = 674,
  kSYS_reserve_2mb_page = 675,
  kSYS_cpumode_yield = 676,

  kSYS_wait6 = 677,
  kSYS_cap_rights_limit = 678,
  kSYS_cap_ioctls_limit = 679,
  kSYS_cap_ioctls_get = 680,
  kSYS_cap_fcntls_limit = 681,
  kSYS_cap_fcntls_get = 682,
  kSYS_bindat = 683,
  kSYS_connectat = 684,
  kSYS_chflagsat = 685,
  kSYS_accept4 = 686,
  kSYS_pipe2 = 687,
  kSYS_aio_mlock = 688,
  kSYS_procctl = 689,
  kSYS_ppoll = 690,
  kSYS_futimens = 691,
  kSYS_utimensat = 692,
  kSYS_numa_getaffinity = 693,
  kSYS_numa_setaffinity = 694,
  kSYS_apr_submit = 700,
  kSYS_apr_resolve = 701,
  kSYS_apr_stat = 702,
  kSYS_apr_wait = 703,
  kSYS_apr_ctrl = 704,
  kSYS_get_phys_page_size = 705,
  kSYS_begin_app_mount = 706,
  kSYS_end_app_mount = 707,
  kSYS_fsc2h_ctrl = 708,
  kSYS_streamwrite = 709,
  kSYS_app_save = 710,
  kSYS_app_restore = 711,
  kSYS_saved_app_delete = 712,
  kSYS_get_ppr_sdk_compiled_version = 713,
  kSYS_notify_app_event = 714,
  kSYS_ioreq = 715,
  kSYS_openintr = 716,
  kSYS_dl_get_info_2 = 717,
  kSYS_acinfo_add = 718,
  kSYS_acinfo_delete = 719,
  kSYS_acinfo_get_all_for_coredump = 720,
  kSYS_ampr_ctrl_debug = 721,
  kSYS_workspace_ctrl = 722,
};
} // namespace orbis
